;Graphic Routines for D90 demo
;(c) 1989 MJSoft System Software
;Martin Mares

	org	61440

	jp	horrot
	jp	lfill
	jp	ffill
	jp	keyin
	jp	posadr
	jp	rozscr
	jp	oescr
	jp	linsc
	jp	horsc
	jp	ransc
	jp	ransd
	jp	light
	jp	scru
	jp	scrd
	jp	star
	jp	draw
	jp	lines
	jp	linls
	jp	scrr
	jp	attr
	jp	box
	jp	triang
	jp	circle
	jp	plot
	jp	clrws
	jp	wsfill
	jp	shade
	jp	getws
	jp	titles
	jp	titstp
	jp	sint
	jp	rint
	jp	icircl
	jp	print
	jp	sctitl
	jp	anima
	jp	amiga
	jp	amistp
	jp	bordln

;Equates

wscr	equ	53760     ;Misc.
wshi	equ	210

tab	equ	0f900h    ;FFill
tend	equ	0ff00h
tbhi	equ	0f9h
tehi	equ	0ffh

flags	equ	0f900h    ;HorRot

itb	equ	0fd00h    ;SInt
itbhi	equ	0fdh
ira	equ	0fefeh
iraby	equ	0feh

buffer	equ	0f900h    ;Anima
ptrs	equ	0fd00h
ptrshi	equ	0fdh

amibuf	equ	0f900h    ;Amiga

;Lightning Fill

lfill	call	posadr
	ld	b,a
	ld	d,h
	ld	e,l
	call	line
	push	de
uploop	dec	d
	ld	a,d
	and	7
	add	a,0f9h
	jr	c,upc
upr	call	line
	jp	z,uploop
	pop	de
doloop	inc	d
	ld	a,d
	and	7
	jr	z,doc
dor	call	line
	jp	z,doloop
	ret

upc	ld	a,e
	sub	32
	ld	e,a
	jr	c,upr
	ld	a,d
	add	a,8
	ld	d,a
	jp	upr

doc	ld	a,e
	add	a,32
	ld	e,a
	jr	c,dor
	ld	a,d
	sub	8
	ld	d,a
	jp	dor

line	ld	h,d
	ld	l,e
	ld	a,b
	and	(hl)
	ret	nz
	ld	a,b
	or	(hl)
	ld	(hl),a
	ld	c,b
le1	rlc	c
	jr	nc,le3
le2	dec	l
	ld	a,(hl)
	or	a
	jr	nz,le3
	ld	(hl),255
	jp	le2
le3	ld	a,c
	and	(hl)
	jr	nz,ri1
	ld	a,c
	or	(hl)
	ld	(hl),a
	jp	le1
ri1	ld	c,b
	ld	h,d
	ld	l,e
ri2	rrc	c
	jr	nc,ri4
ri3	inc	l
	ld	a,(hl)
	or	a
	jr	nz,ri4
	ld	(hl),255
	jp	ri3
ri4	ld	a,c
	and	(hl)
	jr	nz,ri5
	ld	a,c
	or	(hl)
	ld	(hl),a
	jp	ri2
ri5	xor	a
	ret

;Fast Fill version 1.00

ffill	call	posadr
	ld	c,a
	exx
	ld	hl,tab
	ld	de,tab
	exx
	jp	test
get	exx
	ld	a,l
	cp	e
	jr	z,ge1
ge1r	ld	a,(de)
	exx
	ld	l,a
	exx
	inc	e
	ld	a,(de)
	exx
	ld	h,a
	exx
	inc	e
	ld	a,(de)
	exx
	ld	c,a
	exx
	inc	e
	inc	de
	ld	a,d
	cp	tehi
	jr	z,ge2
ge2r	exx
test	ld	b,l
	ld	d,c
	rlc	d
	jr	c,telt
telr	ld	a,d
	and	(hl)
	call	z,sto
	ld	l,b
	ld	d,c
	rrc	d
	jr	c,tert
terr	ld	a,d
	and	(hl)
	call	z,sto
	ld	l,b
	ld	e,h
	ld	d,c
	inc	h
	ld	a,h
	and	7
	jr	z,tedt
tedr	ld	a,d
	and	(hl)
	call	z,sto
	ld	h,e
	ld	l,b
	dec	h
	ld	a,h
	and	7
	cp	7
	jr	z,teut
teur	ld	a,d
	and	(hl)
	call	z,sto
	jp	get

ge1	ld	a,d
	cp	h
	jp	nz,ge1r
	ret

ge2	ld	d,tbhi
	jp	ge2r

telt	dec	l
	jp	telr

tert	inc	l
	jp	terr

tedt	ld	a,l
	add	a,32
	ld	l,a
	jr	c,tedr
	ld	a,h
	sub	8
	ld	h,a
	jp	tedr

teut	ld	a,l
	sub	32
	ld	l,a
	jr	c,teur
	ld	a,h
	add	a,8
	ld	h,a
	jp	teur

sto	ld	a,l
	exx
	ld	(hl),a
	inc	l
	exx
	ld	a,h
	exx
	ld	(hl),a
	inc	l
	exx
	ld	a,d
	exx
	ld	(hl),a
	inc	l
	inc	hl
	ld	a,h
	cp	tehi
	jr	z,st1
st1r	exx
	ld	a,d
	or	(hl)
	ld	(hl),a
	ret

st1	ld	h,tbhi
	jp	st1r

;Horizontal Axe Rotation

horrot	call	store
	call	clfls
	exx
	ld	de,0
	exx
hrloop	exx
	ld	a,(23560)
	cp	'@'
	jp	z,8
	ld	a,e
	ld	l,(iy+38)
	sla	l
	dec	l
	and	l
	exx
	call	uber
	push	af
	call	uprav
	pop	af
	jr	nc,hrloop
hrlp	exx
	ld	a,(23560)
	cp	'@'
	jp	z,8
	ld	a,e
	ld	l,(iy+38)
	sla	l
	dec	l
	and	l
	add	a,l
	inc	a
	exx
	call	uber
	push	af
	call	uprav
	pop	af
	jr	nc,hrlp
	call	redraw
	halt
	dec	(iy+71)
	jr	nz,hrloop
	ret

store	ld	bc,(23677)
	ld	de,wscr
sto1	push	bc
	ld	a,b
	call	22b1h
	ld	b,0
	ld	c,(iy+37)
	ldir
	pop	bc
	inc	b
	ld	a,b
	cp	(iy+38)
	jr	c,sto1
	ret

clfls	ld	hl,flags
	ld	de,flags+1
	ld	b,0
	ld	c,(iy+38)
	dec	c
	ld	(hl),255
	ldir
	ret

uber	ld	l,a
	ld	h,0
	ld	de,flags
	add	hl,de
	ld	a,(hl)
	or	a
	ret	z
	scf
	ld	(hl),0
	ret

redraw	ld	hl,flags
	ld	c,0
	ld	b,(iy+38)
red1	ld	a,(hl)
	inc	hl
	or	a
	jr	nz,red2
	inc	c
red2	djnz	red1
	ld	a,c
	srl	a
	ld	bc,(23677)
	jr	z,red5
red3	push	af
	push	bc
	ld	a,b
	call	22b1h
	ld	b,(iy+37)
red4	ld	(hl),0
	inc	hl
	djnz	red4
	pop	bc
	pop	af
	inc	b
	dec	a
	jr	nz,red3
red5	ld	ix,flags
	ld	de,wscr
	ld	a,(iy+38)
red6	push	af
	ld	a,(ix)
	inc	ix
	or	a
	jr	z,red7
	push	bc
	ld	a,b
	call	22b1h
	ex	de,hl
	ld	b,0
	ld	c,(iy+37)
	ldir
	ex	de,hl
	pop	bc
	inc	b
	jr	red7b
red7	ld	h,0
	ld	l,(iy+37)
	add	hl,de
	ex	de,hl
red7b	pop	af
	dec	a
	jr	nz,red6
red8	ld	a,b
	cp	(iy+38)
	ret	nc
	push	bc
	ld	a,b
	call	22b1h
	ld	b,(iy+37)
red9	ld	(hl),0
	inc	hl
	djnz	red9
	pop	bc
	inc	b
	jr	red8

uprav	exx
	ld	h,e
	ld	l,(iy+5)
	add	hl,de
	ex	de,hl
	exx
	ret

;WS Lightning Fill version 1.0

wsfill	call	posadr
	ld	b,a
	ld	d,h
	ld	e,l
	call	wline
	push	de
wploop	dec	d
	ld	a,d
	and	7
	add	a,0f9h
	jr	c,wupc
wupr	call	wline
	jp	z,wploop
	pop	de
woloop	inc	d
	ld	a,d
	and	7
	jr	z,wdoc
wdor	call	wline
	jp	z,woloop
	ret

wupc	ld	a,e
	sub	32
	ld	e,a
	jr	c,wupr
	ld	a,d
	add	a,8
	ld	d,a
	jp	wupr

wdoc	ld	a,e
	add	a,32
	ld	e,a
	jr	c,wdor
	ld	a,d
	sub	8
	ld	d,a
	jp	wdor

wline	ld	h,d
	ld	l,e
	ld	a,b
	and	(hl)
	ret	nz
	ld	a,b
	ex	af,af'
	ld	a,h
	add	a,wshi-64
	ld	h,a
	ex	af,af'
	or	(hl)
	ld	(hl),a
	ex	af,af'
	sub	wshi-64
	ld	h,a
	ex	af,af'
	or	(hl)
	ld	(hl),a
	ld	c,b
wle1	rlc	c
	jr	nc,wle3
wle2	dec	l
	ld	a,(hl)
	or	a
	jr	nz,wle3
	ld	(hl),255
	ld	a,h
	add	a,wshi-64
	ld	h,a
	ld	(hl),255
	sub	wshi-64
	ld	h,a
	jp	wle2
wle3	ld	a,c
	and	(hl)
	jr	nz,wri1
	ld	a,c
	ex	af,af'
	ld	a,h
	add	a,wshi-64
	ld	h,a
	ex	af,af'
	or	(hl)
	ld	(hl),a
	ex	af,af'
	sub	wshi-64
	ld	h,a
	ex	af,af'
	or	(hl)
	ld	(hl),a
	jp	wle1
wri1	ld	c,b
	ld	h,d
	ld	l,e
wri2	rrc	c
	jr	nc,wri4
wri3	inc	l
	ld	a,(hl)
	or	a
	jr	nz,wri4
	ld	(hl),255
	ld	a,h
	add	a,wshi-64
	ld	h,a
	ld	(hl),255
	sub	wshi-64
	ld	h,a
	jp	wri3
wri4	ld	a,c
	and	(hl)
	jr	nz,wri5
	ld	a,c
	ex	af,af'
	ld	a,h
	add	a,wshi-64
	ld	h,a
	ex	af,af'
	or	(hl)
	ld	(hl),a
	ex	af,af'
	sub	wshi-64
	ld	h,a
	ex	af,af'
	or	(hl)
	ld	(hl),a
	jp	wri2
wri5	xor	a
	ret

;Rozscrollovani

rozscr	ld	a,128
	ld	hl,roz2+1
	ld	(hl),16
	ld	hl,rozx+1
	ld	(hl),16
	ld	hl,400fh
	ld	(ro1+1),hl
	inc	l
	ld	(ro2+1),hl
	ld	hl,wscr+0fh
	ld	(ro3+1),hl
	inc	l
	ld	(ro4+1),hl
	ld	c,7
roz1	push	af
ro1	ld	hl,400fh
ro3	ld	de,wscr+0fh
	exx
ro2	ld	hl,4010h
ro4	ld	de,wscr+10h
	ld	c,192
roz2	ld	b,16
	and	a
	push	hl
roz3	rr	(hl)
	inc	l
	djnz	roz3
	pop	hl
	exx
	ld	a,c
	exx
	or	a
	jr	nz,roz4
	ld	a,(de)
	ld	(hl),a
roz4	push	bc
	ld	bc,32
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ex	de,hl
	pop	bc
	exx
rozx	ld	b,16
	and	a
	push	hl
roz5	rl	(hl)
	dec	l
	djnz	roz5
	pop	hl
	ld	a,c
	or	a
	jr	nz,roz6
	ld	a,(de)
	ld	(hl),a
roz6	push	bc
	ld	bc,32
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ex	de,hl
	pop	bc
	exx
	dec	c
	jr	nz,roz2
	exx
	ld	a,c
	or	a
	jr	nz,roz7
	ld	hl,(ro1+1)
	dec	hl
	ld	(ro1+1),hl
	ld	hl,(ro2+1)
	inc	hl
	ld	(ro2+1),hl
	ld	hl,(ro3+1)
	dec	hl
	ld	(ro3+1),hl
	ld	hl,(ro4+1)
	inc	hl
	ld	(ro4+1),hl
	ld	hl,roz2+1
	dec	(hl)
	ld	hl,rozx+1
	dec	(hl)
	jp	m,8
roz7	dec	a
	and	7
	ld	c,a
	pop	af
	dec	a
	jr	nz,roz1
	ret

;Print routine

print	ld	l,a
	exx
prchr	ld	a,(ix)
	cp	255
	ret	z
	inc	ix
	exx
	push	bc
	exx
	add	a,a
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	ld	de,(23606)
	add	hl,de
	ld	e,8
prlin	exx
	ld	a,d
	exx
	ld	d,a
prlir	exx
	push	bc
	exx
	ld	c,(hl)
	ld	b,8
prcol	exx
	ld	a,e
	exx
	push	bc
	ld	b,a
prcor	ld	a,c
	and	128
	exx
	jr	z,prnop
	call	plot
prnop	bit	4,l
	jr	nz,prxi1
	inc	c
	bit	0,l
	jr	z,prxi1
	dec	c
	dec	c
prxi1	bit	5,l
	jr	nz,pryi1
	inc	b
	bit	1,l
	jr	z,pryi1
	dec	b
	dec	b
pryi1	exx
	djnz	prcor
	pop	bc
	rl	c
	djnz	prcol
	exx
	pop	bc
	bit	6,l
	jr	nz,prxi2
	inc	c
	bit	2,l
	jr	z,prxi2
	dec	c
	dec	c
prxi2	bit	7,l
	jr	nz,pryi2
	inc	b
	bit	3,l
	jr	z,pryi2
	dec	b
	dec	b
pryi2	exx
	dec	d
	jr	nz,prlir
	inc	l
	dec	e
	jr	nz,prlin
	exx
	pop	bc
	ld	a,e
	add	a,a
	add	a,a
	add	a,a
	ld	h,a
	bit	4,l
	jr	nz,prigx
	ld	a,c
	add	a,h
	bit	0,l
	jr	z,prxi3
	ld	a,c
	sub	h
prxi3	ld	c,a
prigx	bit	5,l
	jr	nz,prigy
	ld	a,b
	add	a,h
	bit	1,l
	jr	z,pryi3
	ld	a,b
	sub	h
pryi3	ld	b,a
prigy	exx
	jp	prchr

;Animator

anima	ld	(aniptr),hl
ancom	ld	de,(aniptr)
	ld	a,(de)
	and	0e0h
	rrca
	rrca
	rrca
	rrca
	ld	l,a
	ld	h,0
	ld	bc,ancot
	add	hl,bc
	ld	bc,ancom
	push	bc
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	ex	de,hl
	ret

anstop	pop	bc
	ret

anset	ld	a,(hl)
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	(aniptr),hl
	and	31
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	bc,buffer
	add	hl,bc
	push	hl
	pop	ix
	ex	de,hl
	ld	bc,32
	ldir
	ld	h,ptrshi
	ld	l,a
	ld	(hl),1
	jp	movs

anres	ld	a,(hl)
	inc	hl
	ld	(aniptr),hl
	and	31
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	bc,buffer
	add	hl,bc
	push	hl
	pop	ix
	ld	l,a
	ld	h,ptrshi
	ld	(hl),0
	jp	rems

anwait	inc	hl
	ld	b,(hl)
	inc	hl
	ld	(aniptr),hl
anwai1	halt
	djnz	anwai1
	ret

ancall	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	hl
	ld	(aniptr),hl
	push	bc
	ret

anresa	inc	hl
	ld	(aniptr),hl
	ld	hl,ptrs
	ld	de,ptrs+1
	ld	bc,31
	ld	(hl),0
	ldir
	ret

anhalt	ld	a,(hl)
	inc	hl
	ld	(aniptr),hl
	and	31
	ld	l,a
	ld	h,ptrshi
	ld	(hl),2
	ret

anexec	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	hl
	ld	(aniptr),hl
anex1	push	bc
	halt
	call	anstep
	pop	bc
	dec	bc
	ld	a,b
	or	c
	jr	nz,anex1
	ret

anstep	ld	hl,ptrs
ans1	ld	a,(hl)
	cp	2
	call	z,anhlt
	or	a
	push	hl
	call	nz,anspr
	pop	hl
	inc	l
	ld	a,l
	cp	32
	jr	c,ans1
	ret

anhlt	halt
	ret

anspr	ld	h,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,buffer
	add	hl,de
	push	hl
	pop	ix
	dec	(ix+21)
	jr	nz,ans2
	ld	a,(ix+20)
	ld	(ix+21),a
	ld	l,(ix+22)
	ld	h,(ix+23)
	call	cjump
ans2	dec	(ix+19)
	ret	nz
	ld	a,(ix+18)
	ld	(ix+19),a
	call	rems
	ld	a,(ix)
	add	a,(ix+10)
	ld	(ix),a
	cp	(ix+3)
	jr	c,ans3
	cp	(ix+2)
	jr	nc,ans3
	ld	a,(ix+1)
	add	a,(ix+11)
	ld	(ix+1),a
	cp	(ix+5)
	jr	c,ans4
	cp	(ix+4)
	jr	c,movs
ans4	ld	l,(ix+8)
	ld	h,(ix+9)
	jp	cjump
ans3	ld	l,(ix+6)
	ld	h,(ix+7)
	jp	cjump

rems	ld	c,(ix)
	ld	b,(ix+1)
	ld	e,(ix+16)
	ld	d,(ix+17)
	ld	a,(ix+13)
rems1	push	af
	push	bc
	ld	a,b
	call	22b1h
	ld	c,(ix+12)
	inc	c
	ld	b,0
	ex	de,hl
	ldir
	ex	de,hl
	pop	bc
	pop	af
	inc	b
	dec	a
	jr	nz,rems1
	ret

movs	ld	c,(ix)
	ld	b,(ix+1)
	ld	a,(ix+13)
	exx
	ld	e,(ix+16)
	ld	d,(ix+17)
	ld	l,(ix+14)
	ld	h,(ix+15)
	exx
movs1	push	af
	push	bc
	ld	a,b
	call	22b1h
	ld	d,a
	push	hl
	exx
	ex	(sp),hl
	ld	b,0
	ld	c,(ix+12)
	inc	c
	ldir
	pop	hl
	exx
	ld	a,8
	sub	d
	ld	e,a
	ld	b,(ix+12)
movs2	ld	a,d
	exx
	ld	b,a
	or	a
	ld	c,(hl)
	inc	hl
	ld	a,(hl)
	dec	hl
	jr	z,movs5
movs3	srl	c
	scf
	rra
	djnz	movs3
	exx
	and	(hl)
	exx
	or	c
	exx
	ld	(hl),a
	inc	l
	ld	a,e
	exx
	ld	b,a
	ld	c,(hl)
	inc	hl
	ld	a,(hl)
	dec	hl
movs4	sla	c
	db	0cbh,37h
	djnz	movs4
movs5	exx
	and	(hl)
	exx
	or	c
	exx
	ld	(hl),a
	ld	a,d
	or	a
	jr	nz,movs6
	inc	l
movs6	djnz	movs2
	exx
	inc	hl
	inc	hl
	exx
	pop	bc
	inc	b
	pop	af
	dec	a
	jr	nz,movs1
	ret

;Amiga Lines

amiga	ld	(aminr),a
	ld	(amist1),de
	ld	(amilr),hl
	exx
	ld	(amist2),de
	ld	(amiud),hl
	exx
	ld	ix,amibuf
	inc	a
ami1	push	af
	ld	(amiptr),ix
	ld	(ix),c
	ld	(ix+1),b
	exx
	ld	(ix+2),c
	ld	(ix+3),b
	exx
	call	amicor
	push	bc
	ld	bc,4
	add	ix,bc
	pop	bc
	pop	af
	dec	a
	jr	nz,ami1
	ld	(amist1),de
	exx
	ld	(amist2),de
	exx
	ld	a,1
	ld	(amirem),a
	ld	a,(aminr)
	ld	ix,amibuf
ami2	push	af
	call	amilin
	ld	bc,4
	add	ix,bc
	pop	af
	dec	a
	jr	nz,ami2
	ret

amistp	ld	ix,(amiptr)
	push	ix
	ld	bc,4
	add	ix,bc
	ld	hl,amirem
	dec	(hl)
	jr	nz,ams1
	ld	a,(aminr)
	inc	a
	ld	(hl),a
	ld	ix,amibuf
ams1	ld	(amiptr),ix
	set	2,(iy+87)
	call	amilin
	res	2,(iy+87)
	ex	(sp),ix
	call	amilin
	push	ix
	pop	hl
	pop	de
	push	de
	pop	ix
	ld	bc,4
	ldir
	ld	c,(ix)
	ld	b,(ix+1)
	ld	de,(amist1)
	exx
	ld	c,(ix+2)
	ld	b,(ix+3)
	ld	de,(amist2)
	exx
	call	amicor
	ld	(ix),c
	ld	(ix+1),b
	ld	(amist1),de
	exx
	ld	(ix+2),c
	ld	(ix+3),b
	ld	(amist2),de
	exx
	ret

amilin	ld	c,(ix)
	ld	b,(ix+1)
	ld	e,(ix+2)
	ld	d,(ix+3)
	jp	draw

amicor	call	amico1
	exx
	call	amico1
	exx
	ret

amico1	ld	hl,(amilr)
amic1b	ld	a,c
	add	a,e
	ld	c,a
	cp	h
	jr	c,amico2
	cp	l
	jr	c,amico3
amico2	ld	a,e
	neg
	ld	e,a
	jr	amic1b
amico3	ld	hl,(amiud)
amic3b	ld	a,b
	add	a,d
	ld	b,a
	cp	h
	jr	c,amico4
	cp	l
	ret	c
amico4	ld	a,d
	neg
	ld	d,a
	jr	amic3b

;Small routines

oescr	xor	a
oe0	ld	bc,0
	push	af
oe1	ld	a,b
	push	bc
	call	22b1h
	ld	b,32
	and	a
oe2	rr	(hl)
	inc	l
	djnz	oe2
	dec	l
	inc	h
	ld	b,32
	and	a
oe3	rl	(hl)
	dec	l
	djnz	oe3
	pop	bc
	inc	b
	inc	b
	ld	a,b
	cp	192
	jr	c,oe1
	pop	af
	dec	a
	jr	nz,oe0
	ret

linsc	ld	bc,0
lsc1	push	bc
	ld	a,b
	call	22b1h
	halt
	ld	b,32
lsc2	ld	(hl),0
	inc	l
	djnz	lsc2
	pop	bc
	inc	b
	ld	a,b
	cp	192
	jr	c,lsc1
	ret

horsc	ld	hl,16384
	ld	de,32
	ld	c,127
hsc2	ld	b,192
	halt
hsc3	ld	a,(hl)
	and	c
	ld	(hl),a
	add	hl,de
	djnz	hsc3
	ld	h,40h
	srl	c
	jr	nz,hsc2
	ld	c,127
	inc	l
	ld	a,l
	and	31
	jr	nz,hsc2
	ret

ransc	ld	de,0
	ld	ix,bittb
	jr	rsc2
rsc1	ld	a,d
	or	e
	ret	z
rsc2	ld	h,d
	ld	l,e
	ld	a,h
	cp	192
	jr	nc,rsc3
	srl	h
	rr	l
	scf
	rr	h
	rr	l
	srl	h
	rr	l
	ld	a,e
	and	7
	ld	(rscf+2),a
rscf	ld	a,(ix)
	cpl
	and	(hl)
	ld	(hl),a
rsc3	ld	h,e
	ld	l,13
	add	hl,de
	ex	de,hl
	jr	rsc1

ransd	ld	de,0
	ld	ix,bittb
	jr	rsd2
rsd1	ld	a,d
	or	e
	ret	z
rsd2	ld	h,d
	ld	l,e
	ld	a,h
	cp	192
	jr	nc,rsd3
	srl	h
	rr	l
	scf
	rr	h
	rr	l
	srl	h
	rr	l
	push	hl
	ld	a,h
	sub	64
	ld	h,a
	ld	bc,wscr
	add	hl,bc
	ld	c,(hl)
	pop	hl
	ld	a,e
	and	7
	ld	(rsdf+2),a
rsdf	ld	b,(ix)
	ld	a,c
	and	b
	or	(hl)
	ld	(hl),a
rsd3	ld	h,e
	ld	l,13
	add	hl,de
	ex	de,hl
	jr	rsd1

light	ld	bc,768
	ld	hl,22528
	halt
	halt
	halt
lig1	ld	(hl),d
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,lig1
	inc	d
	ex	af,af'
	or	a
	jr	z,lig2
	dec	d
	dec	d
lig2	ex	af,af'
	ld	a,d
	cp	e
	jr	nz,light
	ret

scru	ld	a,192
su1	push	af
	ld	hl,57e0h
	ld	b,32
su2	ld	(hl),0
	inc	l
	djnz	su2
	ld	bc,256
	ld	de,16384
su3	push	bc
	ld	a,b
	call	22b1h
	push	hl
	ld	bc,32
	ldir
	pop	de
	pop	bc
	inc	b
	ld	a,b
	cp	192
	jr	c,su3
	pop	af
	dec	a
	jr	nz,su1
	ret

scrd	ld	a,192
sd1	push	af
	ld	hl,4000h
	ld	b,32
sd2	ld	(hl),0
	inc	l
	djnz	sd2
	ld	bc,0bf00h
	ld	de,57e0h
sd3	push	bc
	ld	a,b
	call	22b1h
	push	hl
	ld	bc,32
	ldir
	pop	de
	pop	bc
	dec	b
	ld	a,b
	inc	a
	jr	nz,sd3
	pop	af
	dec	a
	jr	nz,sd1
	ret

star	ld	a,c
	push	de
	push	bc
	call	2d28h
	pop	af
	call	2d28h
	pop	bc
	call	2d2bh
	jp	2394h

lines	xor	a
ls1	push	af
	ld	e,a
	ld	d,175
	ld	bc,0
	call	draw
	pop	af
	cp	176
	jr	nc,ls2
	push	af
	ld	d,a
	ld	e,255
	ld	bc,0
	call	draw
	pop	af
ls2	inc	a
	inc	a
	jr	nz,ls1
	ret

linls	ld	d,1
lls1	ld	bc,0
lls2	push	bc
	ld	a,b
	call	22b1h
	ld	b,32
	and	a
lls3	rr	(hl)
	inc	l
	djnz	lls3
	pop	bc
	inc	b
	ld	a,b
	cp	d
	jr	c,lls2
	inc	d
	ld	a,d
	cp	193
	jr	c,lls1
	ret

scrr	ld	d,0
sr1	ld	hl,16384
	ld	c,192
sr2	ld	b,32
	and	a
sr3	rr	(hl)
	inc	hl
	djnz	sr3
	dec	c
	jr	nz,sr2
	dec	d
	jr	nz,sr1
	ret

attr	ld	de,32
at1	push	hl
	push	bc
at2	ld	(hl),a
	inc	l
	djnz	at2
	pop	bc
	pop	hl
	add	hl,de
	dec	c
	jr	nz,at1
	ret

box	push	de
	push	bc
	ld	b,d
	push	bc
	call	draw      ;de-dc
	pop	bc
	pop	de
	push	de
	call	draw      ;dc-bc
	pop	bc
	pop	de
	push	de
	ld	d,b
	push	de
	call	draw      ;bc-be
	pop	bc
	pop	de
	jp	draw      ;be-de

triang	push	bc
	push	hl
	push	de
	push	hl
	call	draw
	pop	bc
	pop	de
	call	draw
	pop	bc
	pop	de
	jp	draw

circle	ld	d,0
	ld	e,a
	add	a,a
	exx
	ld	e,a
	ld	d,0
	ld	hl,3
	and	a
	sbc	hl,de
	ld	b,h
	ld	c,l       ;P=3-2*ra
	exx
	dec	d
loop	inc	d
	push	de
	call	cplot
	ld	a,e
	ld	e,d
	ld	d,a
	call	cplot
	pop	de
	ld	a,d
	cp	e
	ret	nc
	exx
	ld	a,b
	rla
	jr	c,pless0
	exx
	ld	a,d
	sub	e
	exx
	ld	l,a
	rla
	sbc	a,a
	ld	h,a
	add	hl,hl
	add	hl,hl
	ld	de,10
	add	hl,de
	add	hl,bc
	ld	b,h
	ld	c,l
	exx
	dec	e
	jp	loop
pless0	exx
	ld	a,d
	exx
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	ld	de,6
	add	hl,de
	add	hl,bc
	ld	b,h
	ld	c,l
	exx
	jp	loop

getws	ld	hl,wscr
	ld	de,16384
	ld	bc,6144
	ldir
	ret

shade	ld	ix,wscr
	ld	hl,16384
	ld	a,3
sh1	push	af
	ld	c,8
	push	de
sh2	ld	b,0
sh3	ld	a,(de)
	and	(ix)
	cpl
	and	(hl)
	ld	(hl),a
	inc	hl
	inc	ix
	djnz	sh3
	inc	de
	dec	c
	jr	nz,sh2
	pop	de
	pop	af
	dec	a
	jr	nz,sh1
	ret

rint	di
	im	1
	ld	a,3fh
	ld	i,a
	ei
	ret

sint	di
	push	hl
	ld	hl,itb
	ld	de,itb+1
	ld	bc,256
	ld	(hl),iraby
	ldir
	ld	hl,ira
	ld	(hl),0c3h
	inc	hl
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	a,itbhi
	ld	i,a
	im	2
	ei
	ret

titles	ld	(titbeg),hl
	ld	(titact),hl
	ld	a,b
	ld	(titlen),a
	ld	(titadr),de
	ld	a,1
	ld	(titcnt),a
	ret

titstp	push	bc
	push	de
	push	hl
	push	af
	ld	hl,titcnt
	dec	(hl)
	jr	nz,titscr
	ld	(hl),8
	ld	hl,(titact)
	ld	a,(hl)
	inc	a
	jr	nz,titchr
	ld	hl,(titbeg)
titchr	ld	a,(hl)
	inc	hl
	ld	(titact),hl
	add	a,a
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	ld	de,(23606)
	add	hl,de
	ld	de,(titadr)
	ld	b,8
titcl	ld	a,(hl)
	ld	(de),a
	inc	l
	inc	d
	djnz	titcl
titscr	ld	hl,(titadr)
	ld	c,8
tits1	push	hl
	ld	a,(titlen)
	ld	b,a
	and	a
tits2	rl	(hl)
	dec	l
	djnz	tits2
	pop	hl
	inc	h
	dec	c
	jr	nz,tits1
	pop	af
	pop	hl
	pop	de
	pop	bc
	ret

icircl	push	af
	ld	a,0a6h
	ld	(ciinv),a
	ld	de,invtb
	ld	(citab+2),de
	pop	af
	call	circle
	ld	a,0b6h
	ld	(ciinv),a
	ld	hl,bittb
	ld	(citab+2),hl
	ret

sctitl	ld	(titbeg),ix
sctloo	ld	a,(23560)
	or	a
	ret	nz
	ld	a,(ix)
	inc	a
	jr	nz,sctchr
	ld	ix,(titbeg)
sctchr	ld	a,(ix)
	inc	ix
	add	a,a
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	ld	de,(23606)
	add	hl,de
	ld	de,401fh
	ld	b,8
sctchl	ld	a,(hl)
	ld	(de),a
	inc	l
	inc	d
	djnz	sctchl
	ld	a,8
sctscr	push	af
	halt
	ld	hl,401fh
	ld	d,0
	ld	c,8
scts1	push	hl
	and	a
	ld	b,31
scts2	rl	(hl)
	dec	l
	djnz	scts2
	rl	d
	pop	hl
	inc	h
	dec	c
	jr	nz,scts1
	ld	a,d
	ld	(4700h),a
	ld	de,57c0h
	ld	a,(de)
	ex	af,af'
	ld	bc,0be00h
scts3	push	bc
	ld	a,b
	call	22b1h
	ld	a,(hl)
	ld	(de),a
	ld	d,h
	ld	e,l
	pop	bc
	dec	b
	ld	a,b
	cp	7
	jr	nc,scts3
	ex	af,af'
	ld	e,a
	ld	d,0
	ld	hl,50e1h
	ld	c,8
scts4	push	hl
	ld	b,30
	rr	e
scts5	rr	(hl)
	inc	l
	djnz	scts5
	rl	d
	pop	hl
	inc	h
	dec	c
	jr	nz,scts4
	ld	a,d
	ld	(50ffh),a
	ld	de,403fh
	ld	bc,9ffh
scts6	push	bc
	ld	a,b
	call	22b1h
	ld	a,(hl)
	ld	(de),a
	ld	d,h
	ld	e,l
	pop	bc
	inc	b
	ld	a,b
	cp	0b9h
	jr	c,scts6
	pop	af
	dec	a
	jr	nz,sctscr
	jp	sctloo

bordln	ld	b,8
bl1	djnz	bl1
	inc	bc
bl2	ld	a,d
	inc	a
	and	7
	ld	d,a
	out	(254),a
	in	a,(254)
	and	31
	cp	31
	ret	nz
	ld	b,45
bl3	djnz	bl3
	neg
	ld	a,0
	jp	bl2

;Subroutines

cjump	jp	(hl)

cplot	ld	a,l
	add	a,d
	ld	c,a
	ld	a,h
	add	a,e
	ld	b,a
	call	plot
	ld	a,h
	sub	e
	ld	b,a
	call	plot
	ld	a,l
	sub	d
	ld	c,a
	call	plot
	ld	a,h
	add	a,e
	ld	b,a
plot	push	bc
	push	hl
	push	ix
	ld	a,b
	cp	192
	jp	nc,8
	call	posadr
ciinv	or	(hl)
	ld	(hl),a
	pop	ix
	pop	hl
	pop	bc
	ret

posadr	ld	a,b
	call	22b1h
	ld	(find+2),a
citab	ld	ix,bittb
find	ld	a,(ix)
	ret

keyin	ld	(iy-50),0
keyil	ld	a,(23560)
	or	a
	jr	z,keyil
	ret

draw	ld	(23677),bc
	ld	a,d
	sub	b
	ld	d,1
	jr	nc,li1
	neg
	ld	d,255
li1	ld	b,a
	ld	a,e
	sub	c
	ld	e,1
	jr	nc,li2
	neg
	ld	e,255
li2	ld	c,a
	jp	24bah

clrws	ld	hl,wscr
	ld	de,wscr+1
	ld	bc,6143
	ld	(hl),0
	ldir
	ret

;Tables

bittb	db	128,64,32,16
	db	8,4,2,1

invtb	db	127,0bfh,0dfh,0efh
	db	0f7h,0fbh,0fdh,0feh

ancot	dw	anstop,anset
	dw	anres,anwait
	dw	anexec,ancall
	dw	anresa,anhalt

;Variables

titact	ds	2
titbeg	ds	2
titadr	ds	2
titlen	ds	1
titcnt	ds	1

aniptr	ds	2

amist1	ds	2
amist2	ds	2
amilr	ds	2
amiud	ds	2
amiptr	ds	2
amirem	ds	1
aminr	ds	1

zzlast
